function f = fun_residues(z, P, M, W, idx1_sites, idx2_sites)	% Main function 
 	   
    global N
    
    L = length(z);
    
    ind = find(M(:,:,N,:));
    [~, ~, i3] = ind2sub(size(M), ind);
    
    det_poly_negative_order = L/2;
    adj_poly_negative_order = N-min(i3);
    
    zero_poles_uncompensated = det_poly_negative_order - adj_poly_negative_order - 1;
    total_zero_poles = (idx1_sites - idx2_sites + zero_poles_uncompensated);
    
    sum = zeros(N);
    if total_zero_poles <= -2 
        for id1 =1:L
            aux = 1;
            if abs(z(id1)) > 1  % Takes only the poles with |z| <= 1 as residues
                for id2 = 1:L
                    if z(id2) ~= z(id1) % if the roots are different then calculates the denominator of the residues
                        aux = aux*(z(id1)-z(id2));
                    end
                end
                % sum over all the poles with |z| <= 1
                sum = sum - green_adj(z(id1), M, W)*z(id1)^total_zero_poles/(P(1)*aux);
            end
        end
        
    else 
        for id1 =1:L
            aux = 1;
            if abs(z(id1)) < 1  % Takes only the poles with |z| <= 1 as residues
                for id2 = 1:L
                    if z(id2) ~= z(id1) % if the roots are different then calculates the denominator of the residues
                        aux = aux*(z(id1)-z(id2));
                    end
                end
                % sum over all the poles with |z| <= 1
                sum = sum + green_adj(z(id1), M, W)*z(id1)^total_zero_poles/(P(1)*aux);
            end
        end
        
        % Calculates the zero poles which emerge for G_{j,l} when l < j
        
        if total_zero_poles == -1
            aux = 1;
            for id2 = 1:L
                aux = aux*(-z(id2));
            end
            sum = sum + green_adj(0, M, W)/(P(1)*aux);
        end

    end
    
    f = sum; % returns the Fourier transform for one value of the frequency
    
end


function G = green_adj(z, M, W)
    
    global N

    siz=size(M);
    out=zeros(siz);
    for k = 1:N
        offset = N-k;
        i1 = offset+1:siz(4);  
        i2= 1:siz(4)-offset;
        
        out(:,:,k,i1) = M(:,:,k,i2)*W^(N-k);
    end
    ind = find(M(:,:,N,:));
    [~, ~, i3] = ind2sub(size(M), ind);
    
    Adj_z_aux = sum(out,3);
    Adj_z = Adj_z_aux(:,:,min(i3):2*N-min(i3)); 
    
    G = zeros(N);
    if z ~= 0
        for i = 1:2*N-1-2*(min(i3)-1)
            G = G + Adj_z(:,:,i)*z^(i-1);
        end
    else  % Zero poles
        G = Adj_z(:,:,1);
    end
        
    
end
